<template>
  <q-card class="w-300px">
    <transition
      name="opacity"
      mode="out-in"
    >
      <q-card-section v-if="!canStore">
        <div class="c-row">
          <div class="text-12px text-grey">
            尚未排定班表
          </div>
        </div>
      </q-card-section>
      <q-card-section
        v-else
        class="c-col"
      >
        <div class="c-row my-5px">
          <div class="text-12px">
            年月份：{{ props.classSchedule.month }}
          </div>
        </div>
        <q-separator class="!my-10px" />
        <div
          v-for="(value, key) in numberOfJobMap"
          :key="key"
          class="c-row my-5px"
        >
          <div class="text-12px">
            {{ key }}
          </div>
          <q-space />
          <div class="text-12px">
            {{ value }}
          </div>
        </div>
        <q-separator class="!my-10px" />
        <div
          v-for="(value, key) in numberOfJobTypeMap"
          :key="key"
          class="c-row my-5px"
        >
          <div class="text-12px">
            {{ key }}
          </div>
          <q-space />
          <div class="text-12px">
            {{ value }}
          </div>
        </div>
      </q-card-section>
    </transition>
    <q-card-actions>
      <q-input
        v-model="name"
        label="輸入班表名稱"
        dense
        filled
        color="secondary"
      />
      <q-space />
      <q-btn
        unelevated
        :color="storeBtnColor"
        @click="submitStoreClassSchedule"
      >
        儲存班表
      </q-btn>
    </q-card-actions>
    <slot />
  </q-card>
</template>


<script lang='ts' setup>
import { computed, ref } from 'vue';
import { cloneDeep } from 'lodash';
import { createTimestampObj } from '../../common/utils';
import { ClassSchedule, Vacancy } from '../../types/main.type';

import { useQuasar } from 'quasar';
import { useStatisticalData } from '../../composables/use-statistical-data';
import { useMainStore } from '../../store/main.store';

interface Props {
  classSchedule: ClassSchedule;
}

const props = withDefaults(defineProps<Props>(), {
  /** 已排定班表 */
  classSchedule: undefined,
});

const $q = useQuasar();
const store = useMainStore();

const notCompleted = computed(() => {
  if (!props.classSchedule) {
    return false;
  }

  return props.classSchedule.itineraries.some((itinerary) => {
    return itinerary.vacancies.some((vacancy) => {
      return !vacancy.executor;
    });
  });
});
const canStore = computed(() => {
  if (!props.classSchedule) {
    return false;
  }

  return true;
});

const vacancies = computed(() => {
  if (!props.classSchedule) {
    return [];
  }

  return props.classSchedule.itineraries.reduce((acc, dayItinerary) => {
    acc.push(...dayItinerary.vacancies);

    return acc;
  }, [] as Vacancy[]);
});

const { numberOfJobMap, numberOfJobTypeMap } = useStatisticalData({
  vacancies,
});

const name = ref('');
const storeBtnColor = computed(() => {
  if (!canStore.value) {
    return 'grey';
  }

  return 'secondary';
});
const submitStoreClassSchedule = () => {
  if (!props.classSchedule) {
    $q.notify({
      type: 'negative',
      message:
        '尚未排定班表。請在最左側日期選擇器決定排班年月份後，按下「開始排班」',
    });
    return;
  }

  if (!name.value) {
    $q.notify({
      type: 'negative',
      message: '班表名稱不可為空',
    });
    return;
  }

  if (notCompleted.value) {
    $q.notify({
      type: 'negative',
      message: '尚有工作無法排出人員',
    });
    return;
  }

  const classSchedules = store.classSchedules;
  const duplicate = classSchedules.find((item) => {
    return item.name === name.value && item.month === props.classSchedule.month;
  });
  if (duplicate) {
    $q.notify({
      type: 'negative',
      message: `已存在名稱為「${name.value}」之班表，請換一個名稱`,
    });
    return;
  }

  const classSchedule = cloneDeep(props.classSchedule);

  classSchedule.name = name.value;
  classSchedule.timestamp = createTimestampObj();

  store.addClassSchedule(classSchedule);
  $q.notify({
    type: 'positive',
    message: `「${name.value}」班表儲存完成`,
  });
};
</script>
